# -*- coding: utf-8 -*-
import os

from odoo.upgrade import util


def migrate(cr, version):
    if not util.str2bool(os.getenv("GC_PINGS", "0")):
        return

    util._logger.info("GC_PINGS: start")

    query = """
             WITH pings AS (
               SELECT id
                     ,database
                     ,date_trunc('month', ping_time) as ping_month
                     ,LEAD(database, 3) OVER (PARTITION BY database, ip ORDER BY ping_time) as db
                     ,date_trunc('month', LAG(ping_time, 1) OVER(PARTITION BY database, ip ORDER BY ping_time)) as month_prev_ping
                FROM openerp_enterprise_ping
             )
             DELETE
               FROM openerp_enterprise_ping oep
              USING pings p
              WHERE oep.id = p.id
                AND p.db IS NOT NULL
                AND p.ping_month = p.month_prev_ping
    """

    cr.execute(query)

    util._logger.info("GC_PINGS: VACUUM FULL")
    cr.commit()
    cr._cnx.autocommit = True
    cr.execute("VACUUM FULL openerp_enterprise_ping")
    cr.autocommit(False)
    util._logger.info("GC_PINGS: end")
